/* Transposition d'une matrice carrée           */
/* Evaluation du temps d'execution              */  

public class TestTransposition {

/* Fonction de creation d'une vecteur de double */
/* initialise avec des nombres aleatoires       */
/* compris dans l'intervalle [0.0,max]          */
/* et un chiffre apres la virgule               */

  static double [] initRandVecteur(int lignes,
                                     double max) {
    double [] tab = new double[lignes];
    for ( int i = 0 ; i < lignes ; i++ ) {
      tab[i] = ((int) (Math.random()*max*1000.0))/1000.0; }
    return tab;
  }

/* Fonction de creation d'une matrice de double */
/* initialise avec des nombres aleatoires       */
/* compris dans l'intervalle [0.0,max]          */
/* et un chiffre apres la virgule               */

  static double [][] initRandMatrice(int lignes,
                                     int colonnes,
                                     double max) {
    double [][] tab = new double[lignes][colonnes];
    for ( int i = 0 ; i < lignes ; i++ ) {
      for ( int j = 0 ; j < colonnes ; j++ ) {
        tab[i][j] = ((int) (Math.random()*max*1000.0))/1000.0; } }
    return tab;
  }

//////////////////////////////////////////////////

  static void transposition(double [][] m) {
    int n = m.length;
    for ( int i = 0 ; i < n-1 ; i++ ) {
      for ( int j = i+1 ; j < n ; j++ ) {
        double aux = m[i][j];
        m[i][j] = m[j][i];
        m[j][i] = aux; } }
  }

  static void transposition(double [][] m,double [][] mt) {
    int n = m.length;
    for ( int i = 0 ; i < n ; i++ ) {
      for ( int j = 0 ; j < n ; j++ ) {
        mt[j][i] = m[i][j]; } }
  }
  
  static void testsRapiditeTransposition(int temps,int ni,int nf,int inc) {
    Ecran.formater("%6s%12s%14s%22s%14s","Taille","Appels","Temps total","Temps moyen","o(n*n)");
    Ecran.formater("%12s%14s%22s%14s\n","Appels","Temps total","Temps moyen","o(n*n)");
    for ( int n = ni ; n <= nf ; n = n+inc ) { 
      double [][] m = initRandMatrice(n,n,10.0);
      double [][] mt = new double[n][n];
      { Utilitaires.Minuteur minuteur = new Utilitaires.Minuteur();
        minuteur.temps = temps*1000;
        minuteur.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          transposition(m);
          i++; }
        while ( minuteur.enCours) ;
        long t = System.nanoTime()-ti;
        Ecran.formater("%6d%12d%14d%22.3f%14.4f",n,i,t,(double) t/i,((double) t/i)/((double) n*n)); }
      { Utilitaires.Minuteur minuteur = new Utilitaires.Minuteur();
        minuteur.temps = temps*1000;
        minuteur.lancement();
        long i = 0;
        long ti = System.nanoTime();
        double [] w;
        do {
          transposition(m);
          i++; }
        while ( minuteur.enCours) ;
        long t = System.nanoTime()-ti;
        Ecran.formater("%12d%14d%22.3f%14.4f\n",i,t,(double) t/i,((double) t/i)/((double) n*n)); } }
  }

//////////////////////////////////////////////////
  
/* Programme principal                          */

  public static void main(String [] args) {
    int temps;
    int ni;
    int nf;
    int inc;
    Ecran.afficher("Nombre de secondes de test? ");
    temps = Clavier.saisirInt();
    Ecran.afficher("Taille initiale? ");
    ni = Clavier.saisirInt();
    Ecran.afficher("Taille finale  ? ");
    nf = Clavier.saisirInt();
    Ecran.afficher("Increment      ? ");
    inc = Clavier.saisirInt();
    testsRapiditeTransposition(temps,ni,nf,inc);
  }
}